function x = das(y,posX, posM, L, fs)
% The function does a delay and sum over a set of points spesified by posX.
% The received signal at each microphone is in vector y, posM containes the
% positions of these microphones. L indicates half the size of each 
% segment, in bits, the data is convertet into. All is acourding to the 
% description in Yardibi et al's articel

micN=size(y,1);         % number of microphones in array
posN=length(posX);      % number of measurement positions
Ylength = length(y);    % total length of signal
I=floor(Ylength/(2*L)); % number of segments
c=340;                  % speed of sound
df=fs/(2*L);            % frequency bin size
%% preprosessing the signals, splitting in segments and fft of each segment.
Yi = zeros(micN, I, L);
for n = 1:micN                  % for measurement position
    for m = 1:I                 % for segment
        temp=(fft(y(n,((m-1)*2*L+1):(m*2*L)))/(2*L));
        Yi(n,m,:)=temp(1:L);        
    end
end

%% steering vector calculation for normalization constant calculation
auX=zeros(micN,posN,L);
omega = 2*pi*(fs/2)*linspace(0,1,L);
clk=zeros(posN,L);
avX= zeros(micN,posN,L);
aX= zeros(micN,posN,L);
for n = 1:posN                  % for measurement position
    for m = 1:micN              % for microphone position
        d= sqrt((posX(n,1)-posM(m,1))^2+(posX(n,2)-posM(m,2))^2);
        auX(m,n,:)=(1/d).*exp(-(1i.*omega.*d)/c);
        avX(m,n,:)=d.*exp(-(1i.*omega.*d)/c);
    end
    for l=1:L                   % for frequency
        clk(n,l)=norm(auX(:,n,l));  % normalization constant
    end
end
for n = 1:posN                  % for measurement position
    for l=1:L                   % for frequency
        aX(:,n,l)=clk(n,l).*avX(:,n,l);       %(x,omega)
    end
end


%% computing the autocorrolation R

R= zeros(micN, micN,L);

for l=1:L
    for k = 1:I
        R(:,:,l)=R(:,:,l)+Yi(:,k,l)*Yi(:,k,l)';
    end
end
R=(1/I)*R;
R=R*df;

%% computing the power from each point

x=zeros(posN,L);

for n=1:posN                    % for measurement position
    for l=1:L                   % for frequency
            x(n,l)=aX(:,n,l)'*R(:,:,l)*aX(:,n,l);
    end
end
x=(1/(micN^2)).*x;

end